<?php
include(dirname(__FILE__) . '/../../config/config.inc.php');
include(dirname(__FILE__) . '/payvalida.php');
class PayvalidaRedirectModuleFrontController extends ModuleFrontController
{
    public $ssl = true;
    public $display_column_left = false;
    public $display_column_right = false;

    public function initContent()
    {
        /**
         * Get the checkout data.
         */
        parent::initContent();
        $this->context = Context::getContext();
        $cart = $this->context->cart;
        $order_id = $cart->id;
        $payvalida = Module::getInstanceByName('payvalida');
        $api_key = $payvalida->get_api_key();
        $environment = $payvalida->get_mode();
        $fished = $payvalida->get_fixedH();
        $merchid = $payvalida->get_merchID();
        $amount = $this->context->cart->getOrderTotal(true, Cart::BOTH);
        $currencyNum = $this->context->currency->iso_code_num;
        $moneda="";
        if($currencyNum == "840"){
            $moneda = "USD";
        }else if($currencyNum == "170"){
            $moneda = "COP";
        }else{
            $moneda = "Moneda no configurada";
        }
        if ($payvalida->checkCurrency($order_id))
            Tools::redirect('index.php?controller=order&step=1');
        /**
         * Define the enviromennt 1->production mode, 0->sandbox mode
         */
        $environment_orders = (1 == $environment)
            ? 'https://api.payvalida.com/api/v3/porders'
            : 'https://api-test.payvalida.com/api/v3/porders';
        $environment_name = (1 == $environment)
            ? 'Produccion'
            : 'SandBox';
        $emailComprador = Context::getContext()->customer->email;
        $key = $emailComprador . strval(343) . strval($order_id) . strval($moneda) . strval($amount) . $fished;
        $checksum = hash('sha512', $key);
        $reference = new DateTime();
        if (!is_object($myOrder)) {
            $myOrder = new stdClass;
        }
        $myOrder->country = 343;
        $myOrder->email = $emailComprador;
        $myOrder->merchant = $merchid;
        $myOrder->order = strval($order_id);
        $myOrder->money = strval($moneda);
        $myOrder->iva = "0";
        $myOrder->amount = strval($amount);
        $myOrder->description = "Pedido #" . strval($order_id);
        $myOrder->language = "es";
        $myOrder->recurrent = false;
        $myOrder->expiration = strval(date("d/m/Y", strtotime("+1 Months")));
        $myOrder->checksum = $checksum;
        /**
         * Generate the json data.
         */
        $data = json_encode($myOrder);
        /**
         * Api connection.
         */
        $curl = curl_init($environment_orders);
        curl_setopt($curl, CURLOPT_HTTPHEADER, ['Content-Type:application/json']);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_POST, true);
        $response = curl_exec($curl);
        curl_close($curl);
        $obj = json_decode($response, true);
        $chekout = $obj['DATA']['checkout'];
        $finalurl = "https://" . $chekout;
        if ($chekout == "") {
            Tools::redirect('index.php?controller=order&step=1');
        }
        /**
         * Confirm the cart status.
         */
        $cart = $this->context->cart;
        if ($cart->id_customer == 0 ||
            $cart->id_address_delivery == 0 ||
            $cart->id_address_invoice == 0 ||
            !$this->module->active) {
            Tools::redirect('index.php?controller=order&step=1');
        }
        /**
         * Validate the module authorization.
         */
        $authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == $this->module->name) {
                $authorized = true;
                break;
            }
        }
        if (!$authorized)
            die($this->module->l('This payment method is not available.', 'validation'));
        if ($this->module->active == false) {
            Tools::redirect('index.php?controller=order&step=1');
        }
        /**
         * Load the customer.
         */
        $customer = new Customer($cart->id_customer);
        if (!Validate::isLoadedObject($customer))
            Tools::redirect('index.php?controller=order&step=1');
        $secure_key = Context::getContext()->customer->secure_key;
        $payment_status = Configuration::get('PS_OS_PREPARATION');
        $module_name = $this->module->displayName;
        $currency_id = (int)$this->context->currency->id;
        $mailVars = array(
            '{payva_l}' => Configuration::get('PAYVALIDA_LIVE_MODE'),
            '{pv_merch}' => nl2br(Configuration::get('MERCHANTID_PV')),
            '{pv_fixed}' => nl2br(Configuration::get('FIXED_HASH_PV')),
            '{pv_fixed_notif}' => nl2br(Configuration::get('FIXED_HASH_NOTIFICATION_PV'))
        );
        /**
         * Save the cart order and change the status to pendient.
         */
        $this->module->validateOrder($order_id, $payment_status, $amount, $module_name, null, $mailVars, $currency_id, false, $customer->secure_key);
        /**
         * redirect to checkout
         */
        Tools::redirect($finalurl);
    }
}

?>